diff --exclude=CVS -uNrp a/rtp.c b/rtp.c
--- a/rtp.c	2003-11-25 16:15:28.000000000 -0500
+++ b/rtp.c	2004-02-10 01:31:16.508600240 -0500
@@ -43,7 +43,7 @@
 #define TYPE_DONTSEND	 0x3
 #define TYPE_MASK	 0x3
 
-static int dtmftimeout = 300;	/* 300 samples */
+static int dtmftimeout = 3000;	/* 3000 samples */
 
 static int rtpstart = 0;
 static int rtpend = 0;
@@ -66,6 +66,7 @@ struct ast_rtp {
 	unsigned int lastrxts;
 	unsigned int lastividtimestamp;
 	unsigned int lastovidtimestamp;
+	unsigned int lasteventseqn;
 	int lasttxformat;
 	int lastrxformat;
 	int dtmfcount;
@@ -404,11 +405,17 @@ struct ast_frame *ast_rtp_read(struct as
 	  // This is special in-band data that's not one of our codecs
 	  if (rtpPT.code == AST_RTP_DTMF) {
 	    /* It's special -- rfc2833 process it */
-	    f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen);
+	    if (rtp->lasteventseqn <= seqno) {
+	      f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen);
+	      rtp->lasteventseqn = seqno;
+	    }
 	    if (f) return f; else return &null_frame;
 	  } else if (rtpPT.code == AST_RTP_CISCO_DTMF) {
 	    /* It's really special -- process it the Cisco way */
-	    f = process_cisco_dtmf(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen);
+	    if (rtp->lasteventseqn <= seqno) {
+	      f = process_cisco_dtmf(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen);
+	      rtp->lasteventseqn = seqno;
+	    }
 	    if (f) return f; else return &null_frame;
 	  } else if (rtpPT.code == AST_RTP_CN) {
 	    /* Comfort Noise */
